#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK3x68x68TN3x2x68_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=3, NB=68, KB=68, 
 * lda=68, ldb=68, ldc=0, mu=3, nu=2, ku=68, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *stM = A + 204;
   const float *stN = B + 4624;
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*3*2)/(3*68);
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 68
   const int incAm = 136, incAn = -204;
   #define incBk 68
   const int incBm = -68, incBn = 136;
   const int incAk0 = ((incAk) / 68), incBk0 = ((incBk) / 68);
   #define incCm 6
   const int incCn = (((ldc) << 2)) - 6;
   float *pC0=C, *pC1=pC0+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2;
   register float rB0, rB1;
   register float m0, m1, m2, m3;
   register float rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1;
   do /* N-loop */
   {
      ATL_pfl1R(pfA);
      pfA += incPFA;
      rA0 = beta;
      rC0_0 = *pC0;
      rC0_0 *= rA0;
      rC1_0 = pC0[2];
      rC1_0 *= rA0;
      rC2_0 = pC0[4];
      rC2_0 *= rA0;
      rC0_1 = *pC1;
      rC0_1 *= rA0;
      rC1_1 = pC1[2];
      rC1_1 *= rA0;
      rC2_1 = pC1[4];
      rC2_1 *= rA0;
/*
 *    Start pipeline
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[68];
      m0 = rA0 * rB0;
      rA2 = pA0[136];
      m1 = rA1 * rB0;
      rB1 = pB0[68];
      m2 = rA2 * rB0;
      m3 = rA0 * rB1;

/*
 *    Completely unrolled K-loop
 */
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[1];
      rB0 = pB0[1];
      rA1 = pA0[69];
      rA2 = pA0[137];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[69];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[2];
      rB0 = pB0[2];
      rA1 = pA0[70];
      rA2 = pA0[138];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[70];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[3];
      rB0 = pB0[3];
      rA1 = pA0[71];
      rA2 = pA0[139];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[71];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[4];
      rB0 = pB0[4];
      rA1 = pA0[72];
      rA2 = pA0[140];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[72];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[5];
      rB0 = pB0[5];
      rA1 = pA0[73];
      rA2 = pA0[141];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[73];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[6];
      rB0 = pB0[6];
      rA1 = pA0[74];
      rA2 = pA0[142];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[74];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[7];
      rB0 = pB0[7];
      rA1 = pA0[75];
      rA2 = pA0[143];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[75];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[8];
      rB0 = pB0[8];
      rA1 = pA0[76];
      rA2 = pA0[144];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[76];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[9];
      rB0 = pB0[9];
      rA1 = pA0[77];
      rA2 = pA0[145];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[77];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[10];
      rB0 = pB0[10];
      rA1 = pA0[78];
      rA2 = pA0[146];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[78];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[11];
      rB0 = pB0[11];
      rA1 = pA0[79];
      rA2 = pA0[147];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[79];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[12];
      rB0 = pB0[12];
      rA1 = pA0[80];
      rA2 = pA0[148];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[80];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[13];
      rB0 = pB0[13];
      rA1 = pA0[81];
      rA2 = pA0[149];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[81];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[14];
      rB0 = pB0[14];
      rA1 = pA0[82];
      rA2 = pA0[150];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[82];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[15];
      rB0 = pB0[15];
      rA1 = pA0[83];
      rA2 = pA0[151];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[83];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[16];
      rB0 = pB0[16];
      rA1 = pA0[84];
      rA2 = pA0[152];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[84];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[17];
      rB0 = pB0[17];
      rA1 = pA0[85];
      rA2 = pA0[153];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[85];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[18];
      rB0 = pB0[18];
      rA1 = pA0[86];
      rA2 = pA0[154];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[86];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[19];
      rB0 = pB0[19];
      rA1 = pA0[87];
      rA2 = pA0[155];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[87];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[20];
      rB0 = pB0[20];
      rA1 = pA0[88];
      rA2 = pA0[156];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[88];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[21];
      rB0 = pB0[21];
      rA1 = pA0[89];
      rA2 = pA0[157];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[89];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[22];
      rB0 = pB0[22];
      rA1 = pA0[90];
      rA2 = pA0[158];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[90];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[23];
      rB0 = pB0[23];
      rA1 = pA0[91];
      rA2 = pA0[159];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[91];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[24];
      rB0 = pB0[24];
      rA1 = pA0[92];
      rA2 = pA0[160];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[92];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[25];
      rB0 = pB0[25];
      rA1 = pA0[93];
      rA2 = pA0[161];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[93];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[26];
      rB0 = pB0[26];
      rA1 = pA0[94];
      rA2 = pA0[162];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[94];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[27];
      rB0 = pB0[27];
      rA1 = pA0[95];
      rA2 = pA0[163];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[95];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[28];
      rB0 = pB0[28];
      rA1 = pA0[96];
      rA2 = pA0[164];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[96];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[29];
      rB0 = pB0[29];
      rA1 = pA0[97];
      rA2 = pA0[165];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[97];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[30];
      rB0 = pB0[30];
      rA1 = pA0[98];
      rA2 = pA0[166];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[98];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[31];
      rB0 = pB0[31];
      rA1 = pA0[99];
      rA2 = pA0[167];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[99];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[32];
      rB0 = pB0[32];
      rA1 = pA0[100];
      rA2 = pA0[168];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[100];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[33];
      rB0 = pB0[33];
      rA1 = pA0[101];
      rA2 = pA0[169];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[101];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[34];
      rB0 = pB0[34];
      rA1 = pA0[102];
      rA2 = pA0[170];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[102];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[35];
      rB0 = pB0[35];
      rA1 = pA0[103];
      rA2 = pA0[171];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[103];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[36];
      rB0 = pB0[36];
      rA1 = pA0[104];
      rA2 = pA0[172];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[104];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[37];
      rB0 = pB0[37];
      rA1 = pA0[105];
      rA2 = pA0[173];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[105];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[38];
      rB0 = pB0[38];
      rA1 = pA0[106];
      rA2 = pA0[174];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[106];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[39];
      rB0 = pB0[39];
      rA1 = pA0[107];
      rA2 = pA0[175];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[107];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[40];
      rB0 = pB0[40];
      rA1 = pA0[108];
      rA2 = pA0[176];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[108];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[41];
      rB0 = pB0[41];
      rA1 = pA0[109];
      rA2 = pA0[177];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[109];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[42];
      rB0 = pB0[42];
      rA1 = pA0[110];
      rA2 = pA0[178];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[110];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[43];
      rB0 = pB0[43];
      rA1 = pA0[111];
      rA2 = pA0[179];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[111];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[44];
      rB0 = pB0[44];
      rA1 = pA0[112];
      rA2 = pA0[180];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[112];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[45];
      rB0 = pB0[45];
      rA1 = pA0[113];
      rA2 = pA0[181];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[113];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[46];
      rB0 = pB0[46];
      rA1 = pA0[114];
      rA2 = pA0[182];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[114];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[47];
      rB0 = pB0[47];
      rA1 = pA0[115];
      rA2 = pA0[183];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[115];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[48];
      rB0 = pB0[48];
      rA1 = pA0[116];
      rA2 = pA0[184];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[116];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[49];
      rB0 = pB0[49];
      rA1 = pA0[117];
      rA2 = pA0[185];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[117];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[50];
      rB0 = pB0[50];
      rA1 = pA0[118];
      rA2 = pA0[186];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[118];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[51];
      rB0 = pB0[51];
      rA1 = pA0[119];
      rA2 = pA0[187];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[119];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[52];
      rB0 = pB0[52];
      rA1 = pA0[120];
      rA2 = pA0[188];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[120];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[53];
      rB0 = pB0[53];
      rA1 = pA0[121];
      rA2 = pA0[189];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[121];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[54];
      rB0 = pB0[54];
      rA1 = pA0[122];
      rA2 = pA0[190];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[122];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[55];
      rB0 = pB0[55];
      rA1 = pA0[123];
      rA2 = pA0[191];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[123];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[56];
      rB0 = pB0[56];
      rA1 = pA0[124];
      rA2 = pA0[192];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[124];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[57];
      rB0 = pB0[57];
      rA1 = pA0[125];
      rA2 = pA0[193];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[125];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[58];
      rB0 = pB0[58];
      rA1 = pA0[126];
      rA2 = pA0[194];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[126];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[59];
      rB0 = pB0[59];
      rA1 = pA0[127];
      rA2 = pA0[195];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[127];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[60];
      rB0 = pB0[60];
      rA1 = pA0[128];
      rA2 = pA0[196];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[128];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[61];
      rB0 = pB0[61];
      rA1 = pA0[129];
      rA2 = pA0[197];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[129];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[62];
      rB0 = pB0[62];
      rA1 = pA0[130];
      rA2 = pA0[198];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[130];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[63];
      rB0 = pB0[63];
      rA1 = pA0[131];
      rA2 = pA0[199];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[131];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[64];
      rB0 = pB0[64];
      rA1 = pA0[132];
      rA2 = pA0[200];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[132];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[65];
      rB0 = pB0[65];
      rA1 = pA0[133];
      rA2 = pA0[201];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[133];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rA0 = pA0[66];
      rB0 = pB0[66];
      rA1 = pA0[134];
      rA2 = pA0[202];
      rC2_0 += m0;
      m0 = rA0 * rB0;
      rB1 = pB0[134];
      rC0_1 += m1;
      m1 = rA1 * rB0;
      rC1_1 += m2;
      m2 = rA2 * rB0;
      rC2_1 += m3;
      m3 = rA0 * rB1;
      rC0_0 += m0;
      m0 = rA1 * rB1;
      rC1_0 += m1;
      m1 = rA2 * rB1;
      rA0 = pA0[67];
      rB0 = pB0[67];
      rA1 = pA0[135];
      rA2 = pA0[203];
      rC2_0 += m2;
      m2 = rA0 * rB0;
      rB1 = pB0[135];
      rC0_1 += m3;
      m3 = rA1 * rB0;
      rC1_1 += m0;
      m0 = rA2 * rB0;
      rC2_1 += m1;
      m1 = rA0 * rB1;
/*
 *    Drain pipe on last iteration of K-loop
 */
      rC0_0 += m2;
      m2 = rA1 * rB1;
      rC1_0 += m3;
      m3 = rA2 * rB1;
      rC2_0 += m0;
      rC0_1 += m1;
      rC1_1 += m2;
      rC2_1 += m3;
      pA0 += incAk;
      pB0 += incBk;
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      pC0[4] = rC2_0;
      *pC1 = rC0_1;
      pC1[2] = rC1_1;
      pC1[4] = rC2_1;
      pC0 += incCm;
      pC1 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK68x68x68TN68x68x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=68, NB=68, KB=68, 
 * lda=68, ldb=68, ldc=0, mu=5, nu=2, ku=68, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 4420;
   const float *stN = B + 4624;
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*5*2)/(68*68);
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 68
   const int incAm = 272, incAn = -4420;
   #define incBk 68
   const int incBm = -68, incBn = 136;
   const int incAk0 = ((incAk) / 68), incBk0 = ((incBk) / 68);
   #define incCm 10
   const int incCn = (((ldc) << 2)) - 130;
   float *pC0=C, *pC1=pC0+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4;
   register float rB0, rB1;
   register float m0, m1, m2, m3;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[2];
         rC1_0 *= rA0;
         rC2_0 = pC0[4];
         rC2_0 *= rA0;
         rC3_0 = pC0[6];
         rC3_0 *= rA0;
         rC4_0 = pC0[8];
         rC4_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC1_1 = pC1[2];
         rC1_1 *= rA0;
         rC2_1 = pC1[4];
         rC2_1 *= rA0;
         rC3_1 = pC1[6];
         rC3_1 *= rA0;
         rC4_1 = pC1[8];
         rC4_1 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[68];
         m0 = rA0 * rB0;
         rA2 = pA0[136];
         m1 = rA1 * rB0;
         rA3 = pA0[204];
         m2 = rA2 * rB0;
         rA4 = pA0[272];
         m3 = rA3 * rB0;
         rB1 = pB0[68];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[69];
         rA2 = pA0[137];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[205];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[273];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[69];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[70];
         rA2 = pA0[138];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[206];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[274];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[70];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA0[71];
         rA2 = pA0[139];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[207];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[275];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[71];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA0[72];
         rA2 = pA0[140];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[208];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[276];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[72];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rA1 = pA0[73];
         rA2 = pA0[141];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[209];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[277];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[73];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rA1 = pA0[74];
         rA2 = pA0[142];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[210];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[278];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[74];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rA1 = pA0[75];
         rA2 = pA0[143];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[211];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[279];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[75];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rA1 = pA0[76];
         rA2 = pA0[144];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[212];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[280];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[76];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rA1 = pA0[77];
         rA2 = pA0[145];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[213];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[281];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[77];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rA1 = pA0[78];
         rA2 = pA0[146];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[214];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[282];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[78];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rA1 = pA0[79];
         rA2 = pA0[147];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[215];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[283];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[79];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rA1 = pA0[80];
         rA2 = pA0[148];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[216];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[284];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[80];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rA1 = pA0[81];
         rA2 = pA0[149];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[217];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[285];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[81];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rA1 = pA0[82];
         rA2 = pA0[150];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[218];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[286];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[82];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rA1 = pA0[83];
         rA2 = pA0[151];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[219];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[287];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[83];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rA1 = pA0[84];
         rA2 = pA0[152];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[220];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[288];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[84];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rA1 = pA0[85];
         rA2 = pA0[153];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[221];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[289];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[85];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rA1 = pA0[86];
         rA2 = pA0[154];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[222];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[290];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[86];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rA1 = pA0[87];
         rA2 = pA0[155];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[223];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[291];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[87];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rA1 = pA0[88];
         rA2 = pA0[156];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[224];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[292];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[88];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rA1 = pA0[89];
         rA2 = pA0[157];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[225];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[293];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[89];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rA1 = pA0[90];
         rA2 = pA0[158];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[226];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[294];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[90];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rA1 = pA0[91];
         rA2 = pA0[159];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[227];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[295];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[91];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rA1 = pA0[92];
         rA2 = pA0[160];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[228];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[296];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[92];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rA1 = pA0[93];
         rA2 = pA0[161];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[229];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[297];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[93];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rA1 = pA0[94];
         rA2 = pA0[162];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[230];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[298];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[94];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rA1 = pA0[95];
         rA2 = pA0[163];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[231];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[299];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[95];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rA1 = pA0[96];
         rA2 = pA0[164];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[232];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[300];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[96];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rA1 = pA0[97];
         rA2 = pA0[165];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[233];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[301];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[97];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rA1 = pA0[98];
         rA2 = pA0[166];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[234];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[302];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[98];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rA1 = pA0[99];
         rA2 = pA0[167];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[235];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[303];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[99];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rA1 = pA0[100];
         rA2 = pA0[168];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[236];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[304];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[100];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[33];
         rB0 = pB0[33];
         rA1 = pA0[101];
         rA2 = pA0[169];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[237];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[305];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[101];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rA1 = pA0[102];
         rA2 = pA0[170];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[238];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[306];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[102];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[35];
         rB0 = pB0[35];
         rA1 = pA0[103];
         rA2 = pA0[171];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[239];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[307];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[103];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rA1 = pA0[104];
         rA2 = pA0[172];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[240];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[308];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[104];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[37];
         rB0 = pB0[37];
         rA1 = pA0[105];
         rA2 = pA0[173];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[241];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[309];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[105];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rA1 = pA0[106];
         rA2 = pA0[174];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[242];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[310];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[106];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[39];
         rB0 = pB0[39];
         rA1 = pA0[107];
         rA2 = pA0[175];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[243];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[311];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[107];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[40];
         rB0 = pB0[40];
         rA1 = pA0[108];
         rA2 = pA0[176];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[244];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[312];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[108];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[41];
         rB0 = pB0[41];
         rA1 = pA0[109];
         rA2 = pA0[177];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[245];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[313];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[109];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[42];
         rB0 = pB0[42];
         rA1 = pA0[110];
         rA2 = pA0[178];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[246];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[314];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[110];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[43];
         rB0 = pB0[43];
         rA1 = pA0[111];
         rA2 = pA0[179];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[247];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[315];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[111];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[44];
         rB0 = pB0[44];
         rA1 = pA0[112];
         rA2 = pA0[180];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[248];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[316];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[112];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[45];
         rB0 = pB0[45];
         rA1 = pA0[113];
         rA2 = pA0[181];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[249];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[317];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[113];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[46];
         rB0 = pB0[46];
         rA1 = pA0[114];
         rA2 = pA0[182];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[250];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[318];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[114];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[47];
         rB0 = pB0[47];
         rA1 = pA0[115];
         rA2 = pA0[183];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[251];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[319];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[115];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[48];
         rB0 = pB0[48];
         rA1 = pA0[116];
         rA2 = pA0[184];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[252];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[320];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[116];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[49];
         rB0 = pB0[49];
         rA1 = pA0[117];
         rA2 = pA0[185];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[253];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[321];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[117];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[50];
         rB0 = pB0[50];
         rA1 = pA0[118];
         rA2 = pA0[186];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[254];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[322];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[118];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[51];
         rB0 = pB0[51];
         rA1 = pA0[119];
         rA2 = pA0[187];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[255];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[323];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[119];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[52];
         rB0 = pB0[52];
         rA1 = pA0[120];
         rA2 = pA0[188];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[256];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[324];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[120];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[53];
         rB0 = pB0[53];
         rA1 = pA0[121];
         rA2 = pA0[189];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[257];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[325];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[121];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[54];
         rB0 = pB0[54];
         rA1 = pA0[122];
         rA2 = pA0[190];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[258];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[326];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[122];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[55];
         rB0 = pB0[55];
         rA1 = pA0[123];
         rA2 = pA0[191];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[259];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[327];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[123];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[56];
         rB0 = pB0[56];
         rA1 = pA0[124];
         rA2 = pA0[192];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[260];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[328];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[124];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[57];
         rB0 = pB0[57];
         rA1 = pA0[125];
         rA2 = pA0[193];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[261];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[329];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[125];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[58];
         rB0 = pB0[58];
         rA1 = pA0[126];
         rA2 = pA0[194];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[262];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[330];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[126];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[59];
         rB0 = pB0[59];
         rA1 = pA0[127];
         rA2 = pA0[195];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[263];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[331];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[127];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[60];
         rB0 = pB0[60];
         rA1 = pA0[128];
         rA2 = pA0[196];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[264];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[332];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[128];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[61];
         rB0 = pB0[61];
         rA1 = pA0[129];
         rA2 = pA0[197];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[265];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[333];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[129];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[62];
         rB0 = pB0[62];
         rA1 = pA0[130];
         rA2 = pA0[198];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[266];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[334];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[130];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[63];
         rB0 = pB0[63];
         rA1 = pA0[131];
         rA2 = pA0[199];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[267];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[335];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[131];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[64];
         rB0 = pB0[64];
         rA1 = pA0[132];
         rA2 = pA0[200];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[268];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[336];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[132];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[65];
         rB0 = pB0[65];
         rA1 = pA0[133];
         rA2 = pA0[201];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[269];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[337];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[133];
         rC4_1 += m1;
         m1 = rA3 * rB0;
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rA0 = pA0[66];
         rB0 = pB0[66];
         rA1 = pA0[134];
         rA2 = pA0[202];
         rC1_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[270];
         rC2_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[338];
         rC3_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[134];
         rC4_1 += m3;
         m3 = rA3 * rB0;
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA0 * rB1;
         rC2_0 += m2;
         m2 = rA1 * rB1;
         rC3_0 += m3;
         m3 = rA2 * rB1;
         rC4_0 += m0;
         m0 = rA3 * rB1;
         rC0_1 += m1;
         m1 = rA4 * rB1;
         rA0 = pA0[67];
         rB0 = pB0[67];
         rA1 = pA0[135];
         rA2 = pA0[203];
         rC1_1 += m2;
         m2 = rA0 * rB0;
         rA3 = pA0[271];
         rC2_1 += m3;
         m3 = rA1 * rB0;
         rA4 = pA0[339];
         rC3_1 += m0;
         m0 = rA2 * rB0;
         rB1 = pB0[135];
         rC4_1 += m1;
         m1 = rA3 * rB0;
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA0 * rB1;
         rC2_0 += m0;
         m0 = rA1 * rB1;
         rC3_0 += m1;
         m1 = rA2 * rB1;
         rC4_0 += m2;
         m2 = rA3 * rB1;
         rC0_1 += m3;
         m3 = rA4 * rB1;
         rC1_1 += m0;
         rC2_1 += m1;
         rC3_1 += m2;
         rC4_1 += m3;
         pA0 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         pC1[4] = rC2_1;
         pC1[6] = rC3_1;
         pC1[8] = rC4_1;
         pC0 += incCm;
         pC1 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_cJIK3x68x68TN3x2x68_a1_bX(3, 68, 68, alpha, ca + 4420, lda, cb, ldb, beta, cc + 130, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
