#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK2x52x52NN2x2x4_aX_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=2, NB=52, KB=52, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=2, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *stM = A + 4;
   const float *stN = B + (104*(ldb));
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 4 - (104*(lda)), incAn = -4;
   #define incBk 8
   const int incBm = -104, incBn = (((ldb) << 2));
   #define incAk0 incAk
   const int incBk0 = ((incBk) >> 2);
   #define incCm 4
   const int incCn = (((ldc) << 2)) - 4;
   float *pC0=C, *pC1=pC0+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(((ldb) << 1));
   register int k;
   register float rA0, rA1;
   register float rB0, rB1;
   register float m0, m1;
   register float rC0_0, rC1_0, rC0_1, rC1_1;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      rA0 = BetaAlpha;
      rC0_0 = *pC0;
      rC0_0 *= rA0;
      rC1_0 = pC0[2];
      rC1_0 *= rA0;
      rC0_1 = *pC1;
      rC0_1 *= rA0;
      rC1_1 = pC1[2];
      rC1_1 *= rA0;
/*
 *    Start pipeline
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[2];
      m0 = rA0 * rB0;
      rB1 = *pB1;
      m1 = rA1 * rB0;

      for (k=48; k; k -= 4) /* easy loop to unroll */
      {
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC1_0 += m1;
         m1 = rA1 * rB1;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[2];
         rB1 = pB1[2];
         rC0_1 += m0;
         m0 = rA0 * rB0;
         rC1_1 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC1_0 += m1;
         m1 = rA1 * rB1;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[4];
         rA1 = pA0[2];
         rB1 = pB1[4];
         rC0_1 += m0;
         m0 = rA0 * rB0;
         rC1_1 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC1_0 += m1;
         m1 = rA1 * rB1;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[6];
         rA1 = pA0[2];
         rB1 = pB1[6];
         rC0_1 += m0;
         m0 = rA0 * rB0;
         rC1_1 += m1;
         m1 = rA1 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC1_0 += m1;
         m1 = rA1 * rB1;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[8];
         rA1 = pA0[2];
         rB1 = pB1[8];
         rC0_1 += m0;
         m0 = rA0 * rB0;
         rC1_1 += m1;
         m1 = rA1 * rB0;
         pB0 += incBk;
         pB1 += incBk;
      } /* end K-loop */
      rC0_0 += m0;
      m0 = rA0 * rB1;
      rC1_0 += m1;
      m1 = rA1 * rB1;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[2];
      rA1 = pA0[2];
      rB1 = pB1[2];
      rC0_1 += m0;
      m0 = rA0 * rB0;
      rC1_1 += m1;
      m1 = rA1 * rB0;
      rC0_0 += m0;
      m0 = rA0 * rB1;
      rC1_0 += m1;
      m1 = rA1 * rB1;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[4];
      rA1 = pA0[2];
      rB1 = pB1[4];
      rC0_1 += m0;
      m0 = rA0 * rB0;
      rC1_1 += m1;
      m1 = rA1 * rB0;
      rC0_0 += m0;
      m0 = rA0 * rB1;
      rC1_0 += m1;
      m1 = rA1 * rB1;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[6];
      rA1 = pA0[2];
      rB1 = pB1[6];
      rC0_1 += m0;
      m0 = rA0 * rB0;
      rC1_1 += m1;
      m1 = rA1 * rB0;
      pB0 += (((incBk0) << 1)+incBk0);
      pB1 += (((incBk0) << 1)+incBk0);
/*
 *    Drain pipe on last iteration of K-loop
 */
      rC0_0 += m0;
      m0 = rA0 * rB1;
      rC1_0 += m1;
      m1 = rA1 * rB1;
      pA0 += incAk0;
      rC0_1 += m0;
      rC1_1 += m1;
      pB0 += incBk0;
      pB1 += incBk0;
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC1_0 *= rB0;
      rC1_1 *= rB0;
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      *pC1 = rC0_1;
      pC1[2] = rC1_1;
      pC0 += incCm;
      pC1 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pB1 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK52x52x52NN0x0x0_aX_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=52, NB=52, KB=52, 
 * lda=0, ldb=0, ldc=0, mu=5, nu=2, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 100;
   const float *stN = B + (104*(ldb));
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 10 - (104*(lda)), incAn = -100;
   #define incBk 8
   const int incBm = -104, incBn = (((ldb) << 2));
   #define incAk0 incAk
   const int incBk0 = ((incBk) >> 2);
   #define incCm 10
   const int incCn = (((ldc) << 2)) - 100;
   float *pC0=C, *pC1=pC0+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(((ldb) << 1));
   register int k;
   register float rA0, rA1, rA2, rA3, rA4;
   register float rB0, rB1;
   register float m0, m1;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[2];
         rC1_0 *= rA0;
         rC2_0 = pC0[4];
         rC2_0 *= rA0;
         rC3_0 = pC0[6];
         rC3_0 *= rA0;
         rC4_0 = pC0[8];
         rC4_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC1_1 = pC1[2];
         rC1_1 *= rA0;
         rC2_1 = pC1[4];
         rC2_1 *= rA0;
         rC3_1 = pC1[6];
         rC3_1 *= rA0;
         rC4_1 = pC1[8];
         rC4_1 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         m0 = rA0 * rB0;
         rA2 = pA0[4];
         m1 = rA1 * rB0;
         rA3 = pA0[6];

         for (k=48; k; k -= 4) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA2 * rB0;
            rA4 = pA0[8];
            rC1_0 += m1;
            m1 = rA3 * rB0;
            rB1 = *pB1;
            rC2_0 += m0;
            m0 = rA4 * rB0;
            rC3_0 += m1;
            m1 = rA0 * rB1;
            rC4_0 += m0;
            m0 = rA1 * rB1;
            rC0_1 += m1;
            m1 = rA2 * rB1;
            rC1_1 += m0;
            m0 = rA3 * rB1;
            rC2_1 += m1;
            m1 = rA4 * rB1;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rA1 = pA0[2];
            rA2 = pA0[4];
            rC3_1 += m0;
            m0 = rA0 * rB0;
            rA3 = pA0[6];
            rC4_1 += m1;
            m1 = rA1 * rB0;
            rA4 = pA0[8];
            rC0_0 += m0;
            m0 = rA2 * rB0;
            rB1 = pB1[2];
            rC1_0 += m1;
            m1 = rA3 * rB0;
            rC2_0 += m0;
            m0 = rA4 * rB0;
            rC3_0 += m1;
            m1 = rA0 * rB1;
            rC4_0 += m0;
            m0 = rA1 * rB1;
            rC0_1 += m1;
            m1 = rA2 * rB1;
            rC1_1 += m0;
            m0 = rA3 * rB1;
            rC2_1 += m1;
            m1 = rA4 * rB1;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rA1 = pA0[2];
            rA2 = pA0[4];
            rC3_1 += m0;
            m0 = rA0 * rB0;
            rA3 = pA0[6];
            rC4_1 += m1;
            m1 = rA1 * rB0;
            rA4 = pA0[8];
            rC0_0 += m0;
            m0 = rA2 * rB0;
            rB1 = pB1[4];
            rC1_0 += m1;
            m1 = rA3 * rB0;
            rC2_0 += m0;
            m0 = rA4 * rB0;
            rC3_0 += m1;
            m1 = rA0 * rB1;
            rC4_0 += m0;
            m0 = rA1 * rB1;
            rC0_1 += m1;
            m1 = rA2 * rB1;
            rC1_1 += m0;
            m0 = rA3 * rB1;
            rC2_1 += m1;
            m1 = rA4 * rB1;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rA1 = pA0[2];
            rA2 = pA0[4];
            rC3_1 += m0;
            m0 = rA0 * rB0;
            rA3 = pA0[6];
            rC4_1 += m1;
            m1 = rA1 * rB0;
            rA4 = pA0[8];
            rC0_0 += m0;
            m0 = rA2 * rB0;
            rB1 = pB1[6];
            rC1_0 += m1;
            m1 = rA3 * rB0;
            rC2_0 += m0;
            m0 = rA4 * rB0;
            rC3_0 += m1;
            m1 = rA0 * rB1;
            rC4_0 += m0;
            m0 = rA1 * rB1;
            rC0_1 += m1;
            m1 = rA2 * rB1;
            rC1_1 += m0;
            m0 = rA3 * rB1;
            rC2_1 += m1;
            m1 = rA4 * rB1;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rA1 = pA0[2];
            rA2 = pA0[4];
            rC3_1 += m0;
            m0 = rA0 * rB0;
            rA3 = pA0[6];
            rC4_1 += m1;
            m1 = rA1 * rB0;
            rA4 = pA0[8];
            pB0 += incBk;
            pB1 += incBk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rB1 = *pB1;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         rC2_0 += m0;
         m0 = rA4 * rB0;
         rC3_0 += m1;
         m1 = rA0 * rB1;
         rC4_0 += m0;
         m0 = rA1 * rB1;
         rC0_1 += m1;
         m1 = rA2 * rB1;
         rC1_1 += m0;
         m0 = rA3 * rB1;
         rC2_1 += m1;
         m1 = rA4 * rB1;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC3_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[6];
         rC4_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[8];
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rB1 = pB1[2];
         rC1_0 += m1;
         m1 = rA3 * rB0;
         rC2_0 += m0;
         m0 = rA4 * rB0;
         rC3_0 += m1;
         m1 = rA0 * rB1;
         rC4_0 += m0;
         m0 = rA1 * rB1;
         rC0_1 += m1;
         m1 = rA2 * rB1;
         rC1_1 += m0;
         m0 = rA3 * rB1;
         rC2_1 += m1;
         m1 = rA4 * rB1;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[4];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC3_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[6];
         rC4_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[8];
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rB1 = pB1[4];
         rC1_0 += m1;
         m1 = rA3 * rB0;
         rC2_0 += m0;
         m0 = rA4 * rB0;
         rC3_0 += m1;
         m1 = rA0 * rB1;
         rC4_0 += m0;
         m0 = rA1 * rB1;
         rC0_1 += m1;
         m1 = rA2 * rB1;
         rC1_1 += m0;
         m0 = rA3 * rB1;
         rC2_1 += m1;
         m1 = rA4 * rB1;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[6];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rC3_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA0[6];
         rC4_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA0[8];
         pB0 += (((incBk0) << 1)+incBk0);
         pB1 += (((incBk0) << 1)+incBk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA2 * rB0;
         rB1 = *pB1;
         rC1_0 += m1;
         m1 = rA3 * rB0;
         rC2_0 += m0;
         m0 = rA4 * rB0;
         rC3_0 += m1;
         m1 = rA0 * rB1;
         rC4_0 += m0;
         m0 = rA1 * rB1;
         rC0_1 += m1;
         m1 = rA2 * rB1;
         rC1_1 += m0;
         m0 = rA3 * rB1;
         rC2_1 += m1;
         m1 = rA4 * rB1;
         pA0 += incAk0;
         rC3_1 += m0;
         rC4_1 += m1;
         pB0 += incBk0;
         pB1 += incBk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC3_0 *= rB0;
         rC3_1 *= rB0;
         rC4_0 *= rB0;
         rC4_1 *= rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         pC1[4] = rC2_1;
         pC1[6] = rC3_1;
         pC1[8] = rC4_1;
         pC0 += incCm;
         pC1 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
   }
   while(pB0 != stN);
   ATL_cJIK2x52x52NN2x2x4_aX_b1(2, 52, 52, alpha, ca + 100, lda, cb, ldb, beta, cc + 100, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
