#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK2x52x52TT2x2x4_aX_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=2, NB=52, KB=52, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=2, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *stM = A + (((lda) << 2));
   const float *stN = B + 104;
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 8
   const int incAm = ((((((lda) << 1)) - 52) << 1)), incAn = -(((lda) << 2));
   const int incBk = (((ldb) << 1)), incBm = -(104*(ldb));
   #define incBn 4
   const int incAk0 = ((incAk) >> 2);
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 2)) - 4;
   float *pC0=C, *pC1=pC0+(((ldc) << 1));
   const float *pA0=A, *pA1=pA0+(((lda) << 1));
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0, rB1;
   register float m0, m1, m2, m3;
   register float rC0_0, rC1_0, rC0_1, rC1_1;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      rC0_0 = rC1_0 = rC0_1 = rC1_1 = 0.0;
/*
 *    Start pipeline
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = *pA1;
      m0 = rA0 * rB0;
      rB1 = pB0[2];
      m1 = rA1 * rB0;
      m2 = rA0 * rB1;
      m3 = rA1 * rB1;
      pB0 += incBk0;
      rA0 = pA0[2];
      rB0 = *pB0;
      rA1 = pA1[2];
      rB1 = pB0[2];

      pA0 += (incAk0);
      pA1 += (incAk0);
      for (k=48; k; k -= 4) /* easy loop to unroll */
      {
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[2];
         rB0 = *pB0;
         rA1 = pA1[2];
         rB1 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[4];
         rB0 = *pB0;
         rA1 = pA1[4];
         rB1 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[6];
         rB0 = *pB0;
         rA1 = pA1[6];
         rB1 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[8];
         rB0 = *pB0;
         rA1 = pA1[8];
         rB1 = pB0[2];
         pA0 += incAk;
         pA1 += incAk;
      } /* end K-loop */
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pB0 += incBk;
      rA0 = pA0[2];
      rB0 = *pB0;
      rA1 = pA1[2];
      rB1 = pB0[2];
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pB0 += incBk;
      rA0 = pA0[4];
      rB0 = *pB0;
      rA1 = pA1[4];
      rB1 = pB0[2];
      pA0 += (((incAk0) << 1));
      pA1 += (((incAk0) << 1));
/*
 *    Drain pipe on last iteration of K-loop
 */
      rC0_0 += m0;
      m0 = rA0 * rB0;
      rC1_0 += m1;
      m1 = rA1 * rB0;
      rC0_1 += m2;
      m2 = rA0 * rB1;
      rC1_1 += m3;
      m3 = rA1 * rB1;
      pB0 += incBk0;
      rC0_0 += m0;
      rC1_0 += m1;
      rC0_1 += m2;
      rC1_1 += m3;
      pA0 += incAk0;
      pA1 += incAk0;
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC1_0 *= rB0;
      rC1_1 *= rB0;
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      *pC1 = rC0_1;
      pC1[2] = rC1_1;
      pC0 += incCm;
      pC1 += incCm;
      pA0 += incAm;
      pA1 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK52x52x52TT0x0x0_aX_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=52, NB=52, KB=52, 
 * lda=0, ldb=0, ldc=0, mu=5, nu=2, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (100*(lda));
   const float *stN = B + 104;
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 8
   const int incAm = ((((((lda) << 2)+lda) - 52) << 1)), incAn = -(100*(lda));
   const int incBk = (((ldb) << 1)), incBm = -(104*(ldb));
   #define incBn 4
   const int incAk0 = ((incAk) >> 2);
   #define incBk0 incBk
   #define incCm 10
   const int incCn = (((ldc) << 2)) - 100;
   float *pC0=C, *pC1=pC0+(((ldc) << 1));
   const float *pA0=A, *pA1=pA0+(((lda) << 1)), *pA2=pA1+(((lda) << 1)), *pA3=pA2+(((lda) << 1)), *pA4=pA3+(((lda) << 1));
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4;
   register float rB0, rB1;
   register float m0, m1, m2, m3, m4;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         rC0_0 = rC1_0 = rC2_0 = rC3_0 = rC4_0 = rC0_1 = rC1_1 = rC2_1 = rC3_1 = rC4_1 = 0.0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         m0 = rA0 * rB0;
         rA2 = *pA2;
         m1 = rA1 * rB0;
         rA3 = *pA3;
         m2 = rA2 * rB0;
         rA4 = *pA4;
         m3 = rA3 * rB0;
         rB1 = pB0[2];
         m4 = rA4 * rB0;

         for (k=48; k; k -= 4) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            rC2_0 += m2;
            m2 = rA2 * rB1;
            rC3_0 += m3;
            m3 = rA3 * rB1;
            rC4_0 += m4;
            m4 = rA4 * rB1;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rA1 = pA1[2];
            rA2 = pA2[2];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rA3 = pA3[2];
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rA4 = pA4[2];
            rC2_1 += m2;
            m2 = rA2 * rB0;
            rB1 = pB0[2];
            rC3_1 += m3;
            m3 = rA3 * rB0;
            rC4_1 += m4;
            m4 = rA4 * rB0;
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            rC2_0 += m2;
            m2 = rA2 * rB1;
            rC3_0 += m3;
            m3 = rA3 * rB1;
            rC4_0 += m4;
            m4 = rA4 * rB1;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rA1 = pA1[4];
            rA2 = pA2[4];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rA3 = pA3[4];
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rA4 = pA4[4];
            rC2_1 += m2;
            m2 = rA2 * rB0;
            rB1 = pB0[2];
            rC3_1 += m3;
            m3 = rA3 * rB0;
            rC4_1 += m4;
            m4 = rA4 * rB0;
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            rC2_0 += m2;
            m2 = rA2 * rB1;
            rC3_0 += m3;
            m3 = rA3 * rB1;
            rC4_0 += m4;
            m4 = rA4 * rB1;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rA1 = pA1[6];
            rA2 = pA2[6];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rA3 = pA3[6];
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rA4 = pA4[6];
            rC2_1 += m2;
            m2 = rA2 * rB0;
            rB1 = pB0[2];
            rC3_1 += m3;
            m3 = rA3 * rB0;
            rC4_1 += m4;
            m4 = rA4 * rB0;
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            rC2_0 += m2;
            m2 = rA2 * rB1;
            rC3_0 += m3;
            m3 = rA3 * rB1;
            rC4_0 += m4;
            m4 = rA4 * rB1;
            pB0 += incBk;
            rA0 = pA0[8];
            rB0 = *pB0;
            rA1 = pA1[8];
            rA2 = pA2[8];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rA3 = pA3[8];
            rC1_1 += m1;
            m1 = rA1 * rB0;
            rA4 = pA4[8];
            rC2_1 += m2;
            m2 = rA2 * rB0;
            rB1 = pB0[2];
            rC3_1 += m3;
            m3 = rA3 * rB0;
            rC4_1 += m4;
            m4 = rA4 * rB0;
            pA0 += incAk;
            pA1 += incAk;
            pA2 += incAk;
            pA3 += incAk;
            pA4 += incAk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC1_0 += m1;
         m1 = rA1 * rB1;
         rC2_0 += m2;
         m2 = rA2 * rB1;
         rC3_0 += m3;
         m3 = rA3 * rB1;
         rC4_0 += m4;
         m4 = rA4 * rB1;
         pB0 += incBk;
         rA0 = pA0[2];
         rB0 = *pB0;
         rA1 = pA1[2];
         rA2 = pA2[2];
         rC0_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[2];
         rC1_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA4[2];
         rC2_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[2];
         rC3_1 += m3;
         m3 = rA3 * rB0;
         rC4_1 += m4;
         m4 = rA4 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC1_0 += m1;
         m1 = rA1 * rB1;
         rC2_0 += m2;
         m2 = rA2 * rB1;
         rC3_0 += m3;
         m3 = rA3 * rB1;
         rC4_0 += m4;
         m4 = rA4 * rB1;
         pB0 += incBk;
         rA0 = pA0[4];
         rB0 = *pB0;
         rA1 = pA1[4];
         rA2 = pA2[4];
         rC0_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[4];
         rC1_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA4[4];
         rC2_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[2];
         rC3_1 += m3;
         m3 = rA3 * rB0;
         rC4_1 += m4;
         m4 = rA4 * rB0;
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC1_0 += m1;
         m1 = rA1 * rB1;
         rC2_0 += m2;
         m2 = rA2 * rB1;
         rC3_0 += m3;
         m3 = rA3 * rB1;
         rC4_0 += m4;
         m4 = rA4 * rB1;
         pB0 += incBk;
         rA0 = pA0[6];
         rB0 = *pB0;
         rA1 = pA1[6];
         rA2 = pA2[6];
         rC0_1 += m0;
         m0 = rA0 * rB0;
         rA3 = pA3[6];
         rC1_1 += m1;
         m1 = rA1 * rB0;
         rA4 = pA4[6];
         rC2_1 += m2;
         m2 = rA2 * rB0;
         rB1 = pB0[2];
         rC3_1 += m3;
         m3 = rA3 * rB0;
         rC4_1 += m4;
         m4 = rA4 * rB0;
         pA0 += (((incAk0) << 1)+incAk0);
         pA1 += (((incAk0) << 1)+incAk0);
         pA2 += (((incAk0) << 1)+incAk0);
         pA3 += (((incAk0) << 1)+incAk0);
         pA4 += (((incAk0) << 1)+incAk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC1_0 += m1;
         m1 = rA1 * rB1;
         rC2_0 += m2;
         m2 = rA2 * rB1;
         rC3_0 += m3;
         m3 = rA3 * rB1;
         rC4_0 += m4;
         m4 = rA4 * rB1;
         pB0 += incBk0;
         rC0_1 += m0;
         rC1_1 += m1;
         rC2_1 += m2;
         rC3_1 += m3;
         rC4_1 += m4;
         pA0 += incAk0;
         pA1 += incAk0;
         pA2 += incAk0;
         pA3 += incAk0;
         pA4 += incAk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC3_0 *= rB0;
         rC3_1 *= rB0;
         rC4_0 *= rB0;
         rC4_1 *= rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         pC1[4] = rC2_1;
         pC1[6] = rC3_1;
         pC1[8] = rC4_1;
         pC0 += incCm;
         pC1 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pA3 += incAm;
         pA4 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pA4 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_cJIK2x52x52TT2x2x4_aX_b0(2, 52, 52, alpha, ca + (100*(lda)), lda, cb, ldb, beta, cc + 100, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
