#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_zJIK80x80x80NN0x0x0_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=80, NB=80, KB=80, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=4, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const double *stM = A + 160;
   const double *stN = B + (((ldb) << 7)+((ldb) << 5));
   const double *pfA = A + lda*M;
   const int incAk = (((lda) << 1));
   const int incAm = 4 - (156*(lda)), incAn = -160;
   #define incBk 12
   const int incBm = -156, incBn = (((ldb) << 3));
   #define incCm 4
   const int incCn = (((ldc) << 3)) - 160;
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(((ldb) << 1)), *pB2=pB1+(((ldb) << 1)), *pB3=pB2+(((ldb) << 1));
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      ATL_pfl1R(pfA+48);
      ATL_pfl1R(pfA+56);
      ATL_pfl1R(pfA+64);
      ATL_pfl1R(pfA+72);
      pfA += lda;
      do /* M-loop */
      {
         rC0_0 = *pC0;
         rC1_0 = pC0[2];
         rC0_1 = *pC1;
         rC1_1 = pC1[2];
         rC0_2 = *pC2;
         rC1_2 = pC2[2];
         rC0_3 = *pC3;
         rC1_3 = pC3[2];
         for (k=78; k; k -= 6) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[2];
            rC0_0 += rA0 * rB0;
            rB1 = *pB1;
            rB2 = *pB2;
            rB3 = *pB3;
            rC1_0 += rA1 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rA1 = pA0[2];
            rC0_0 += rA0 * rB0;
            rB1 = pB1[2];
            rB2 = pB2[2];
            rB3 = pB3[2];
            rC1_0 += rA1 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[4];
            rA1 = pA0[2];
            rC0_0 += rA0 * rB0;
            rB1 = pB1[4];
            rB2 = pB2[4];
            rB3 = pB3[4];
            rC1_0 += rA1 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[6];
            rA1 = pA0[2];
            rC0_0 += rA0 * rB0;
            rB1 = pB1[6];
            rB2 = pB2[6];
            rB3 = pB3[6];
            rC1_0 += rA1 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[8];
            rA1 = pA0[2];
            rC0_0 += rA0 * rB0;
            rB1 = pB1[8];
            rB2 = pB2[8];
            rB3 = pB3[8];
            rC1_0 += rA1 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[10];
            rA1 = pA0[2];
            rC0_0 += rA0 * rB0;
            rB1 = pB1[10];
            rB2 = pB2[10];
            rB3 = pB3[10];
            rC1_0 += rA1 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            pA0 += incAk;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
            pB3 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rC0_0 += rA0 * rB0;
         rB1 = *pB1;
         rB2 = *pB2;
         rB3 = *pB3;
         rC1_0 += rA1 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[2];
         rC0_0 += rA0 * rB0;
         rB1 = pB1[2];
         rB2 = pB2[2];
         rB3 = pB3[2];
         rC1_0 += rA1 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         pA0 += incAk;
         pA0 -= 2*incAk;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         *pC2 = rC0_2;
         pC2[2] = rC1_2;
         *pC3 = rC0_3;
         pC3[2] = rC1_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
