#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x0TN1x1x1_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   #define incAk 1
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 1
   const int incBm = -(Kb), incBn = (ldb);
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=K; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x0TN1x1x12_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=12, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)/12)*12, kr = K - Kloop - 2;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   #define incAk 12
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 12
   const int incBm = -(Kb), incBn = (ldb);
   const int incAk0 = ((incAk) / 12), incBk0 = ((incBk) / 12);
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0;
   register float rC0_0;
   if (K < 3)
   {
      ATL_cJIK0x0x0TN1x1x1_a1_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];

         pA0 += (incAk0);
         pB0 += (incBk0);
         for (k=Kloop; k; k -= 12) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
         switch(kr)
         {
         case 1:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            pA0 += (incAk0);
            pB0 += (incBk0);
            break;
         case 2:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            pA0 += (((incAk0) << 1));
            pB0 += (((incBk0) << 1));
            break;
         case 3:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            pA0 += (((incAk0) << 1)+incAk0);
            pB0 += (((incBk0) << 1)+incBk0);
            break;
         case 4:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            pA0 += (((incAk0) << 2));
            pB0 += (((incBk0) << 2));
            break;
         case 5:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            pA0 += (((incAk0) << 2)+incAk0);
            pB0 += (((incBk0) << 2)+incBk0);
            break;
         case 6:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            pA0 += (((incAk0) << 2)+((incAk0) << 1));
            pB0 += (((incBk0) << 2)+((incBk0) << 1));
            break;
         case 7:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            pA0 += (7*(incAk0));
            pB0 += (7*(incBk0));
            break;
         case 8:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            pA0 += (((incAk0) << 3));
            pB0 += (((incBk0) << 3));
            break;
         case 9:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            pA0 += (((incAk0) << 3)+incAk0);
            pB0 += (((incBk0) << 3)+incBk0);
            break;
         case 10:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            pA0 += (((incAk0) << 3)+((incAk0) << 1));
            pB0 += (((incBk0) << 3)+((incBk0) << 1));
            break;
         case 11:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            pA0 += (11*(incAk0));
            pB0 += (11*(incBk0));
            break;
         case 0: ;
         }
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         pA0 += incAk0;
         pB0 += incBk0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_cJIK0x0x0TN5x1x12_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=5, nu=1, ku=12, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const int Mb = (M/5)*5;
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)/12)*12, kr = K - Kloop - 2;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   #define incAk 12
   const int incAm = ((((lda) << 2)+lda) - Kb), incAn = -(Mb*lda);
   #define incBk 12
   const int incBm = -(Kb), incBn = (ldb);
   const int incAk0 = ((incAk) / 12), incBk0 = ((incBk) / 12);
   #define incCm 10
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda);
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4;
   register float rB0;
   register float m0, m1, m2, m3, m4;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0;
   if (K < 3)
   {
      ATL_cJIK0x0x0TN1x1x1_a1_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
            rC2_0 = pC0[4];
            rC2_0 *= rA0;
            rC3_0 = pC0[6];
            rC3_0 *= rA0;
            rC4_0 = pC0[8];
            rC4_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = *pA1;
            m0 = rA0 * rB0;
            rA2 = *pA2;
            m1 = rA1 * rB0;
            rA3 = *pA3;
            m2 = rA2 * rB0;
            rA4 = *pA4;
            m3 = rA3 * rB0;
            m4 = rA4 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA1[1];
            rA2 = pA2[1];

            pA0 += (incAk0);
            pA1 += (incAk0);
            pA2 += (incAk0);
            pA3 += (incAk0);
            pA4 += (incAk0);
            pB0 += (incBk0);
            for (k=Kloop; k; k -= 12) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = *pA3;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = *pA4;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[1];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[2];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[3];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[4];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[5];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[6];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[7];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[8];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[9];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[10];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[11];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               pA0 += incAk;
               pA1 += incAk;
               pA2 += incAk;
               pA3 += incAk;
               pA4 += incAk;
               pB0 += incBk;
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = *pA3;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = *pA4;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               pA0 += (incAk0);
               pA1 += (incAk0);
               pA2 += (incAk0);
               pA3 += (incAk0);
               pA4 += (incAk0);
               pB0 += (incBk0);
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = *pA3;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = *pA4;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[1];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               pA0 += (((incAk0) << 1));
               pA1 += (((incAk0) << 1));
               pA2 += (((incAk0) << 1));
               pA3 += (((incAk0) << 1));
               pA4 += (((incAk0) << 1));
               pB0 += (((incBk0) << 1));
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = *pA3;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = *pA4;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[1];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[2];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               pA0 += (((incAk0) << 1)+incAk0);
               pA1 += (((incAk0) << 1)+incAk0);
               pA2 += (((incAk0) << 1)+incAk0);
               pA3 += (((incAk0) << 1)+incAk0);
               pA4 += (((incAk0) << 1)+incAk0);
               pB0 += (((incBk0) << 1)+incBk0);
               break;
            case 4:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = *pA3;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = *pA4;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[1];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[2];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[3];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               pA0 += (((incAk0) << 2));
               pA1 += (((incAk0) << 2));
               pA2 += (((incAk0) << 2));
               pA3 += (((incAk0) << 2));
               pA4 += (((incAk0) << 2));
               pB0 += (((incBk0) << 2));
               break;
            case 5:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = *pA3;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = *pA4;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[1];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[2];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[3];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[4];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               pA0 += (((incAk0) << 2)+incAk0);
               pA1 += (((incAk0) << 2)+incAk0);
               pA2 += (((incAk0) << 2)+incAk0);
               pA3 += (((incAk0) << 2)+incAk0);
               pA4 += (((incAk0) << 2)+incAk0);
               pB0 += (((incBk0) << 2)+incBk0);
               break;
            case 6:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = *pA3;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = *pA4;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[1];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[2];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[3];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[4];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[5];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               pA0 += (((incAk0) << 2)+((incAk0) << 1));
               pA1 += (((incAk0) << 2)+((incAk0) << 1));
               pA2 += (((incAk0) << 2)+((incAk0) << 1));
               pA3 += (((incAk0) << 2)+((incAk0) << 1));
               pA4 += (((incAk0) << 2)+((incAk0) << 1));
               pB0 += (((incBk0) << 2)+((incBk0) << 1));
               break;
            case 7:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = *pA3;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = *pA4;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[1];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[2];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[3];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[4];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[5];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[6];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               pA0 += (7*(incAk0));
               pA1 += (7*(incAk0));
               pA2 += (7*(incAk0));
               pA3 += (7*(incAk0));
               pA4 += (7*(incAk0));
               pB0 += (7*(incBk0));
               break;
            case 8:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = *pA3;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = *pA4;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[1];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[2];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[3];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[4];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[5];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[6];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[7];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               pA0 += (((incAk0) << 3));
               pA1 += (((incAk0) << 3));
               pA2 += (((incAk0) << 3));
               pA3 += (((incAk0) << 3));
               pA4 += (((incAk0) << 3));
               pB0 += (((incBk0) << 3));
               break;
            case 9:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = *pA3;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = *pA4;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[1];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[2];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[3];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[4];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[5];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[6];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[7];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[8];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               pA0 += (((incAk0) << 3)+incAk0);
               pA1 += (((incAk0) << 3)+incAk0);
               pA2 += (((incAk0) << 3)+incAk0);
               pA3 += (((incAk0) << 3)+incAk0);
               pA4 += (((incAk0) << 3)+incAk0);
               pB0 += (((incBk0) << 3)+incBk0);
               break;
            case 10:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = *pA3;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = *pA4;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[1];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[2];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[3];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[4];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[5];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[6];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[7];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[8];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[9];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               pA0 += (((incAk0) << 3)+((incAk0) << 1));
               pA1 += (((incAk0) << 3)+((incAk0) << 1));
               pA2 += (((incAk0) << 3)+((incAk0) << 1));
               pA3 += (((incAk0) << 3)+((incAk0) << 1));
               pA4 += (((incAk0) << 3)+((incAk0) << 1));
               pB0 += (((incBk0) << 3)+((incBk0) << 1));
               break;
            case 11:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = *pA3;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = *pA4;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[1];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[2];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[3];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[4];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[5];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[6];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[7];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[8];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[9];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rA4 = pA4[10];
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rC4_0 += m4;
               m4 = rA4 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               pA0 += (11*(incAk0));
               pA1 += (11*(incAk0));
               pA2 += (11*(incAk0));
               pA3 += (11*(incAk0));
               pA4 += (11*(incAk0));
               pB0 += (11*(incBk0));
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA3 = *pA3;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rA4 = *pA4;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rC4_0 += m4;
            m4 = rA4 * rB0;
            rC0_0 += m0;
            rC1_0 += m1;
            rC2_0 += m2;
            rC3_0 += m3;
            rC4_0 += m4;
            pA0 += incAk0;
            pA1 += incAk0;
            pA2 += incAk0;
            pA3 += incAk0;
            pA4 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            pC0[6] = rC3_0;
            pC0[8] = rC4_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pA2 += incAm;
            pA3 += incAm;
            pA4 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pA2 += incAn;
         pA3 += incAn;
         pA4 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_cJIK0x0x0TN1x1x12_a1_bX(k, N, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x0TN1x2x12_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=2, ku=12, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   #define Mb M
   const int Nb = (N>>1)<<1;
   #define Kb K
   const int Kloop = ((K-2)/12)*12, kr = K - Kloop - 2;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   #define incAk 12
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 12
   const int incBm = -(Kb), incBn = (((ldb) << 1));
   const int incAk0 = ((incAk) / 12), incBk0 = ((incBk) / 12);
   #define incCm 2
   const int incCn = (((ldc) << 2)) - (((Mb) << 1));
   float *pC0=C, *pC1=pC0+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(ldb);
   register int k;
   register float rA0;
   register float rB0, rB1;
   register float m0, m1;
   register float rC0_0, rC0_1;
   if (K < 3)
   {
      ATL_cJIK0x0x0TN1x1x1_a1_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = *pB1;
            m0 = rA0 * rB0;
            m1 = rA0 * rB1;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB1[1];

            pA0 += (incAk0);
            pB0 += (incBk0);
            pB1 += (incBk0);
            for (k=Kloop; k; k -= 12) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB1[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rB1 = pB1[7];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rB1 = pB1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rB1 = pB1[9];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rB1 = pB1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rB1 = pB1[11];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rB1 = pB1[12];
               pA0 += incAk;
               pB0 += incBk;
               pB1 += incBk;
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               pA0 += (incAk0);
               pB0 += (incBk0);
               pB1 += (incBk0);
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               pA0 += (((incAk0) << 1));
               pB0 += (((incBk0) << 1));
               pB1 += (((incBk0) << 1));
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               pA0 += (((incAk0) << 1)+incAk0);
               pB0 += (((incBk0) << 1)+incBk0);
               pB1 += (((incBk0) << 1)+incBk0);
               break;
            case 4:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               pA0 += (((incAk0) << 2));
               pB0 += (((incBk0) << 2));
               pB1 += (((incBk0) << 2));
               break;
            case 5:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB1[5];
               pA0 += (((incAk0) << 2)+incAk0);
               pB0 += (((incBk0) << 2)+incBk0);
               pB1 += (((incBk0) << 2)+incBk0);
               break;
            case 6:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB1[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               pA0 += (((incAk0) << 2)+((incAk0) << 1));
               pB0 += (((incBk0) << 2)+((incBk0) << 1));
               pB1 += (((incBk0) << 2)+((incBk0) << 1));
               break;
            case 7:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB1[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rB1 = pB1[7];
               pA0 += (7*(incAk0));
               pB0 += (7*(incBk0));
               pB1 += (7*(incBk0));
               break;
            case 8:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB1[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rB1 = pB1[7];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rB1 = pB1[8];
               pA0 += (((incAk0) << 3));
               pB0 += (((incBk0) << 3));
               pB1 += (((incBk0) << 3));
               break;
            case 9:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB1[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rB1 = pB1[7];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rB1 = pB1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rB1 = pB1[9];
               pA0 += (((incAk0) << 3)+incAk0);
               pB0 += (((incBk0) << 3)+incBk0);
               pB1 += (((incBk0) << 3)+incBk0);
               break;
            case 10:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB1[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rB1 = pB1[7];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rB1 = pB1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rB1 = pB1[9];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rB1 = pB1[10];
               pA0 += (((incAk0) << 3)+((incAk0) << 1));
               pB0 += (((incBk0) << 3)+((incBk0) << 1));
               pB1 += (((incBk0) << 3)+((incBk0) << 1));
               break;
            case 11:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB1[4];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB1[5];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB1[6];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rB1 = pB1[7];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rB1 = pB1[8];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rB1 = pB1[9];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rB1 = pB1[10];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rB1 = pB1[11];
               pA0 += (11*(incAk0));
               pB0 += (11*(incBk0));
               pB1 += (11*(incBk0));
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC0_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m0;
            rC0_1 += m1;
            pA0 += incAk0;
            pB0 += incBk0;
            pB1 += incBk0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            pC0 += incCm;
            pC1 += incCm;
            pA0 += incAm;
            pB0 += incBm;
            pB1 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pA0 += incAn;
         pB0 += incBn;
         pB1 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_cJIK0x0x0TN1x1x12_a1_bX(M, k, K, alpha, ca, lda, cb + (Nb*ldb), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK0x0x0TN0x0x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=5, nu=2, ku=12, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const int Mb = (M/5)*5;
   const int Nb = (N>>1)<<1;
   #define Kb K
   const int Kloop = ((K-1)/12)*12, kr = K - Kloop - 1;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   #define incAk 12
   const int incAm = ((((lda) << 2)+lda) - Kb), incAn = -(Mb*lda);
   #define incBk 12
   const int incBm = -(Kb), incBn = (((ldb) << 1));
   const int incAk0 = ((incAk) / 12), incBk0 = ((incBk) / 12);
   #define incCm 10
   const int incCn = (((ldc) << 2)) - (((Mb) << 1));
   float *pC0=C, *pC1=pC0+(((ldc) << 1));
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda);
   const float *pB0=B, *pB1=pB0+(ldb);
   register int k;
   register float rA0, rA1, rA2, rA3, rA4;
   register float rB0, rB1;
   register float m0, m1, m2, m3, m4;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            ATL_pfl1R(pfA+0);
            ATL_pfl1R(pfA+16);
            pfA += lda;
            do /* M-loop */
            {
               rA0 = beta;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[2];
               rC1_0 *= rA0;
               rC2_0 = pC0[4];
               rC2_0 *= rA0;
               rC3_0 = pC0[6];
               rC3_0 *= rA0;
               rC4_0 = pC0[8];
               rC4_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[2];
               rC1_1 *= rA0;
               rC2_1 = pC1[4];
               rC2_1 *= rA0;
               rC3_1 = pC1[6];
               rC3_1 *= rA0;
               rC4_1 = pC1[8];
               rC4_1 *= rA0;
/*
 *             Start pipeline
 */
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               m0 = rA0 * rB0;
               rA2 = *pA2;
               m1 = rA1 * rB0;
               rA3 = *pA3;
               m2 = rA2 * rB0;
               rA4 = *pA4;
               m3 = rA3 * rB0;
               rB1 = *pB1;
               m4 = rA4 * rB0;

               for (k=Kloop; k; k -= 12) /* easy loop to unroll */
               {
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[1];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[1];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[1];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[2];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[2];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[2];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[3];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[3];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[3];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[4];
                  rB0 = pB0[4];
                  rA1 = pA1[4];
                  rA2 = pA2[4];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[4];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[4];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[4];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[5];
                  rB0 = pB0[5];
                  rA1 = pA1[5];
                  rA2 = pA2[5];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[5];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[5];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[5];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[6];
                  rB0 = pB0[6];
                  rA1 = pA1[6];
                  rA2 = pA2[6];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[6];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[6];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[6];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[7];
                  rB0 = pB0[7];
                  rA1 = pA1[7];
                  rA2 = pA2[7];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[7];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[7];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[7];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[8];
                  rB0 = pB0[8];
                  rA1 = pA1[8];
                  rA2 = pA2[8];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[8];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[8];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[8];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[9];
                  rB0 = pB0[9];
                  rA1 = pA1[9];
                  rA2 = pA2[9];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[9];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[9];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[9];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[10];
                  rB0 = pB0[10];
                  rA1 = pA1[10];
                  rA2 = pA2[10];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[10];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[10];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[10];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[11];
                  rB0 = pB0[11];
                  rA1 = pA1[11];
                  rA2 = pA2[11];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[11];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[11];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[11];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[12];
                  rB0 = pB0[12];
                  rA1 = pA1[12];
                  rA2 = pA2[12];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[12];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[12];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[12];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  pA0 += incAk;
                  pA1 += incAk;
                  pA2 += incAk;
                  pA3 += incAk;
                  pA4 += incAk;
                  pB0 += incBk;
                  pB1 += incBk;
               } /* end K-loop */
               switch(kr)
               {
               case 1:
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[1];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[1];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[1];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  pA0 += (incAk0);
                  pA1 += (incAk0);
                  pA2 += (incAk0);
                  pA3 += (incAk0);
                  pA4 += (incAk0);
                  pB0 += (incBk0);
                  pB1 += (incBk0);
                  break;
               case 2:
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[1];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[1];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[1];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[2];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[2];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[2];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  pA0 += (((incAk0) << 1));
                  pA1 += (((incAk0) << 1));
                  pA2 += (((incAk0) << 1));
                  pA3 += (((incAk0) << 1));
                  pA4 += (((incAk0) << 1));
                  pB0 += (((incBk0) << 1));
                  pB1 += (((incBk0) << 1));
                  break;
               case 3:
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[1];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[1];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[1];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[2];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[2];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[2];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[3];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[3];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[3];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  pA0 += (((incAk0) << 1)+incAk0);
                  pA1 += (((incAk0) << 1)+incAk0);
                  pA2 += (((incAk0) << 1)+incAk0);
                  pA3 += (((incAk0) << 1)+incAk0);
                  pA4 += (((incAk0) << 1)+incAk0);
                  pB0 += (((incBk0) << 1)+incBk0);
                  pB1 += (((incBk0) << 1)+incBk0);
                  break;
               case 4:
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[1];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[1];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[1];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[2];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[2];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[2];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[3];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[3];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[3];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[4];
                  rB0 = pB0[4];
                  rA1 = pA1[4];
                  rA2 = pA2[4];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[4];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[4];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[4];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  pA0 += (((incAk0) << 2));
                  pA1 += (((incAk0) << 2));
                  pA2 += (((incAk0) << 2));
                  pA3 += (((incAk0) << 2));
                  pA4 += (((incAk0) << 2));
                  pB0 += (((incBk0) << 2));
                  pB1 += (((incBk0) << 2));
                  break;
               case 5:
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[1];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[1];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[1];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[2];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[2];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[2];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[3];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[3];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[3];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[4];
                  rB0 = pB0[4];
                  rA1 = pA1[4];
                  rA2 = pA2[4];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[4];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[4];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[4];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[5];
                  rB0 = pB0[5];
                  rA1 = pA1[5];
                  rA2 = pA2[5];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[5];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[5];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[5];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  pA0 += (((incAk0) << 2)+incAk0);
                  pA1 += (((incAk0) << 2)+incAk0);
                  pA2 += (((incAk0) << 2)+incAk0);
                  pA3 += (((incAk0) << 2)+incAk0);
                  pA4 += (((incAk0) << 2)+incAk0);
                  pB0 += (((incBk0) << 2)+incBk0);
                  pB1 += (((incBk0) << 2)+incBk0);
                  break;
               case 6:
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[1];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[1];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[1];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[2];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[2];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[2];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[3];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[3];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[3];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[4];
                  rB0 = pB0[4];
                  rA1 = pA1[4];
                  rA2 = pA2[4];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[4];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[4];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[4];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[5];
                  rB0 = pB0[5];
                  rA1 = pA1[5];
                  rA2 = pA2[5];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[5];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[5];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[5];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[6];
                  rB0 = pB0[6];
                  rA1 = pA1[6];
                  rA2 = pA2[6];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[6];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[6];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[6];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  pA0 += (((incAk0) << 2)+((incAk0) << 1));
                  pA1 += (((incAk0) << 2)+((incAk0) << 1));
                  pA2 += (((incAk0) << 2)+((incAk0) << 1));
                  pA3 += (((incAk0) << 2)+((incAk0) << 1));
                  pA4 += (((incAk0) << 2)+((incAk0) << 1));
                  pB0 += (((incBk0) << 2)+((incBk0) << 1));
                  pB1 += (((incBk0) << 2)+((incBk0) << 1));
                  break;
               case 7:
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[1];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[1];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[1];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[2];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[2];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[2];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[3];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[3];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[3];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[4];
                  rB0 = pB0[4];
                  rA1 = pA1[4];
                  rA2 = pA2[4];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[4];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[4];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[4];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[5];
                  rB0 = pB0[5];
                  rA1 = pA1[5];
                  rA2 = pA2[5];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[5];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[5];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[5];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[6];
                  rB0 = pB0[6];
                  rA1 = pA1[6];
                  rA2 = pA2[6];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[6];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[6];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[6];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[7];
                  rB0 = pB0[7];
                  rA1 = pA1[7];
                  rA2 = pA2[7];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[7];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[7];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[7];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  pA0 += (7*(incAk0));
                  pA1 += (7*(incAk0));
                  pA2 += (7*(incAk0));
                  pA3 += (7*(incAk0));
                  pA4 += (7*(incAk0));
                  pB0 += (7*(incBk0));
                  pB1 += (7*(incBk0));
                  break;
               case 8:
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[1];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[1];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[1];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[2];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[2];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[2];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[3];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[3];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[3];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[4];
                  rB0 = pB0[4];
                  rA1 = pA1[4];
                  rA2 = pA2[4];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[4];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[4];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[4];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[5];
                  rB0 = pB0[5];
                  rA1 = pA1[5];
                  rA2 = pA2[5];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[5];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[5];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[5];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[6];
                  rB0 = pB0[6];
                  rA1 = pA1[6];
                  rA2 = pA2[6];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[6];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[6];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[6];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[7];
                  rB0 = pB0[7];
                  rA1 = pA1[7];
                  rA2 = pA2[7];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[7];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[7];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[7];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[8];
                  rB0 = pB0[8];
                  rA1 = pA1[8];
                  rA2 = pA2[8];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[8];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[8];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[8];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  pA0 += (((incAk0) << 3));
                  pA1 += (((incAk0) << 3));
                  pA2 += (((incAk0) << 3));
                  pA3 += (((incAk0) << 3));
                  pA4 += (((incAk0) << 3));
                  pB0 += (((incBk0) << 3));
                  pB1 += (((incBk0) << 3));
                  break;
               case 9:
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[1];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[1];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[1];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[2];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[2];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[2];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[3];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[3];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[3];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[4];
                  rB0 = pB0[4];
                  rA1 = pA1[4];
                  rA2 = pA2[4];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[4];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[4];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[4];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[5];
                  rB0 = pB0[5];
                  rA1 = pA1[5];
                  rA2 = pA2[5];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[5];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[5];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[5];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[6];
                  rB0 = pB0[6];
                  rA1 = pA1[6];
                  rA2 = pA2[6];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[6];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[6];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[6];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[7];
                  rB0 = pB0[7];
                  rA1 = pA1[7];
                  rA2 = pA2[7];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[7];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[7];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[7];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[8];
                  rB0 = pB0[8];
                  rA1 = pA1[8];
                  rA2 = pA2[8];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[8];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[8];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[8];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[9];
                  rB0 = pB0[9];
                  rA1 = pA1[9];
                  rA2 = pA2[9];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[9];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[9];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[9];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  pA0 += (((incAk0) << 3)+incAk0);
                  pA1 += (((incAk0) << 3)+incAk0);
                  pA2 += (((incAk0) << 3)+incAk0);
                  pA3 += (((incAk0) << 3)+incAk0);
                  pA4 += (((incAk0) << 3)+incAk0);
                  pB0 += (((incBk0) << 3)+incBk0);
                  pB1 += (((incBk0) << 3)+incBk0);
                  break;
               case 10:
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[1];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[1];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[1];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[2];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[2];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[2];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[3];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[3];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[3];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[4];
                  rB0 = pB0[4];
                  rA1 = pA1[4];
                  rA2 = pA2[4];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[4];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[4];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[4];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[5];
                  rB0 = pB0[5];
                  rA1 = pA1[5];
                  rA2 = pA2[5];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[5];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[5];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[5];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[6];
                  rB0 = pB0[6];
                  rA1 = pA1[6];
                  rA2 = pA2[6];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[6];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[6];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[6];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[7];
                  rB0 = pB0[7];
                  rA1 = pA1[7];
                  rA2 = pA2[7];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[7];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[7];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[7];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[8];
                  rB0 = pB0[8];
                  rA1 = pA1[8];
                  rA2 = pA2[8];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[8];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[8];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[8];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[9];
                  rB0 = pB0[9];
                  rA1 = pA1[9];
                  rA2 = pA2[9];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[9];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[9];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[9];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[10];
                  rB0 = pB0[10];
                  rA1 = pA1[10];
                  rA2 = pA2[10];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[10];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[10];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[10];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  pA0 += (((incAk0) << 3)+((incAk0) << 1));
                  pA1 += (((incAk0) << 3)+((incAk0) << 1));
                  pA2 += (((incAk0) << 3)+((incAk0) << 1));
                  pA3 += (((incAk0) << 3)+((incAk0) << 1));
                  pA4 += (((incAk0) << 3)+((incAk0) << 1));
                  pB0 += (((incBk0) << 3)+((incBk0) << 1));
                  pB1 += (((incBk0) << 3)+((incBk0) << 1));
                  break;
               case 11:
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[1];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[1];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[1];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[2];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[2];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[2];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[3];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[3];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[3];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[4];
                  rB0 = pB0[4];
                  rA1 = pA1[4];
                  rA2 = pA2[4];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[4];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[4];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[4];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[5];
                  rB0 = pB0[5];
                  rA1 = pA1[5];
                  rA2 = pA2[5];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[5];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[5];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[5];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[6];
                  rB0 = pB0[6];
                  rA1 = pA1[6];
                  rA2 = pA2[6];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[6];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[6];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[6];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[7];
                  rB0 = pB0[7];
                  rA1 = pA1[7];
                  rA2 = pA2[7];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[7];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[7];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[7];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[8];
                  rB0 = pB0[8];
                  rA1 = pA1[8];
                  rA2 = pA2[8];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[8];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[8];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[8];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[9];
                  rB0 = pB0[9];
                  rA1 = pA1[9];
                  rA2 = pA2[9];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[9];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[9];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[9];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[10];
                  rB0 = pB0[10];
                  rA1 = pA1[10];
                  rA2 = pA2[10];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[10];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[10];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[10];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rC4_0 += m4;
                  m4 = rA4 * rB1;
                  rA0 = pA0[11];
                  rB0 = pB0[11];
                  rA1 = pA1[11];
                  rA2 = pA2[11];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA3[11];
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rA4 = pA4[11];
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rB1 = pB1[11];
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  rC4_1 += m4;
                  m4 = rA4 * rB0;
                  pA0 += (11*(incAk0));
                  pA1 += (11*(incAk0));
                  pA2 += (11*(incAk0));
                  pA3 += (11*(incAk0));
                  pA4 += (11*(incAk0));
                  pB0 += (11*(incBk0));
                  pB1 += (11*(incBk0));
                  break;
               case 0: ;
               }
/*
 *             Drain pipe on last iteration of K-loop
 */
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rC1_0 += m1;
               m1 = rA1 * rB1;
               rC2_0 += m2;
               m2 = rA2 * rB1;
               rC3_0 += m3;
               m3 = rA3 * rB1;
               rC4_0 += m4;
               m4 = rA4 * rB1;
               rC0_1 += m0;
               rC1_1 += m1;
               rC2_1 += m2;
               rC3_1 += m3;
               rC4_1 += m4;
               pA0 += incAk0;
               pA1 += incAk0;
               pA2 += incAk0;
               pA3 += incAk0;
               pA4 += incAk0;
               pB0 += incBk0;
               pB1 += incBk0;
               *pC0 = rC0_0;
               pC0[2] = rC1_0;
               pC0[4] = rC2_0;
               pC0[6] = rC3_0;
               pC0[8] = rC4_0;
               *pC1 = rC0_1;
               pC1[2] = rC1_1;
               pC1[4] = rC2_1;
               pC1[6] = rC3_1;
               pC1[8] = rC4_1;
               pC0 += incCm;
               pC1 += incCm;
               pA0 += incAm;
               pA1 += incAm;
               pA2 += incAm;
               pA3 += incAm;
               pA4 += incAm;
               pB0 += incBm;
               pB1 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pA0 += incAn;
            pA1 += incAn;
            pA2 += incAn;
            pA3 += incAn;
            pA4 += incAn;
            pB0 += incBn;
            pB1 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_cJIK0x0x0TN5x1x12_a1_bX(M, k, K, alpha, ca, lda, cb + (Nb*ldb), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
   if (Nb && (k=M-Mb))
      ATL_cJIK0x0x0TN1x2x12_a1_bX(k, Nb, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
